﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Linq;
using System.Text;
using System.Xml.Linq;
using System.Windows.Forms;
using DocumentFormat.OpenXml.Packaging;
using OpenXmlPowerTools;

namespace DisplayDocxInWinForm
{
    public partial class Form1 : Form
    {
        private string htmlBaseName;
        private string htmlFileName;
        private string imageDirectoryName;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Multiselect = false;
            DialogResult dr = ofd.ShowDialog();
            if (dr == System.Windows.Forms.DialogResult.OK)
            {
                if (ofd.FileNames.Count() >= 1)
                {
                    htmlFileName = ofd.FileNames[0];
                    ViewWordDoc((new FileInfo(ofd.FileNames[0])).FullName, webBrowser1);
                }
            }
        }

        private void ViewWordDoc(string fileName, WebBrowser webBrowser)
        {
            // This example shows conversion using CSS.  It also converts images.
#if false
            string css = @"
p.PtNormal
{margin-bottom:10.0pt;
font-size:11.0pt;
font-family:""Times"";}
h1.PtHeading1
{margin-top:24.0pt;
font-size:14.0pt;
font-family:""Helvetica"";
color:blue;}
h2.PtHeading2
{margin-top:10.0pt;
font-size:13.0pt;
font-family:""Helvetica"";
color:blue;}             
";
#endif
            string css = 
@"

 /* Font Definitions */
 @font-face
    {font-family:Cambria;
    panose-1:2 4 5 3 5 4 6 3 2 4;}
@font-face
    {font-family:Calibri;
    panose-1:2 15 5 2 2 2 4 3 2 4;}
@font-face
    {font-family:Tahoma;
    panose-1:2 11 6 4 3 5 4 4 2 4;}
 /* Style Definitions */
 p.MsoNormal, li.MsoNormal, div.MsoNormal
    {margin-top:0in;
    margin-right:0in;
    margin-bottom:10.0pt;
    margin-left:0in;
    line-height:115%;
    font-size:11.0pt;
    font-family:'Calibri','sans-serif';}
h1
    {mso-style-link:'Heading 1 Char';
    margin-top:24.0pt;
    margin-right:0in;
    margin-bottom:0in;
    margin-left:0in;
    margin-bottom:.0001pt;
    line-height:115%;
    page-break-after:avoid;
    font-size:14.0pt;
    font-family:'Cambria','serif';
    color:#365F91;}
h2
    {mso-style-link:'Heading 2 Char';
    margin-top:10.0pt;
    margin-right:0in;
    margin-bottom:0in;
    margin-left:0in;
    margin-bottom:.0001pt;
    line-height:115%;
    page-break-after:avoid;
    font-size:13.0pt;
    font-family:'Cambria','serif';
    color:#4F81BD;}
p.MsoTitle, li.MsoTitle, div.MsoTitle
    {mso-style-link:'Title Char';
    margin-top:0in;
    margin-right:0in;
    margin-bottom:15.0pt;
    margin-left:0in;
    border:none;
    padding:0in;
    font-size:26.0pt;
    font-family:'Cambria','serif';
    color:#17365D;
    letter-spacing:.25pt;}
p.MsoTitleCxSpFirst, li.MsoTitleCxSpFirst, div.MsoTitleCxSpFirst
    {mso-style-link:'Title Char';
    margin:0in;
    margin-bottom:.0001pt;
    border:none;
    padding:0in;
    font-size:26.0pt;
    font-family:'Cambria','serif';
    color:#17365D;
    letter-spacing:.25pt;}
p.MsoTitleCxSpMiddle, li.MsoTitleCxSpMiddle, div.MsoTitleCxSpMiddle
    {mso-style-link:'Title Char';
    margin:0in;
    margin-bottom:.0001pt;
    border:none;
    padding:0in;
    font-size:26.0pt;
    font-family:'Cambria','serif';
    color:#17365D;
    letter-spacing:.25pt;}
p.MsoTitleCxSpLast, li.MsoTitleCxSpLast, div.MsoTitleCxSpLast
    {mso-style-link:'Title Char';
    margin-top:0in;
    margin-right:0in;
    margin-bottom:15.0pt;
    margin-left:0in;
    border:none;
    padding:0in;
    font-size:26.0pt;
    font-family:'Cambria','serif';
    color:#17365D;
    letter-spacing:.25pt;}
p.MsoAcetate, li.MsoAcetate, div.MsoAcetate
    {mso-style-link:'Balloon Text Char';
    margin:0in;
    margin-bottom:.0001pt;
    font-size:8.0pt;
    font-family:'Tahoma','sans-serif';}
span.TitleChar
    {mso-style-name:'Title Char';
    mso-style-link:Title;
    font-family:'Cambria','serif';
    color:#17365D;
    letter-spacing:.25pt;}
span.Heading1Char
    {mso-style-name:'Heading 1 Char';
    mso-style-link:'Heading 1';
    font-family:'Cambria','serif';
    color:#365F91;
    font-weight:bold;}
span.Heading2Char
    {mso-style-name:'Heading 2 Char';
    mso-style-link:'Heading 2';
    font-family:'Cambria','serif';
    color:#4F81BD;
    font-weight:bold;}
span.BalloonTextChar
    {mso-style-name:'Balloon Text Char';
    mso-style-link:'Balloon Text';
    font-family:'Tahoma','sans-serif';}
.MsoChpDefault
    {font-family:'Calibri','sans-serif';}
.MsoPapDefault
    {margin-bottom:10.0pt;
    line-height:115%;}
@page WordSection1
    {size:8.5in 11.0in;
    margin:1.0in 1.0in 1.0in 1.0in;}
div.WordSection1
    {page:WordSection1;}

";

            string sourceDocumentFileName = fileName;
            FileInfo fileInfo = new FileInfo(sourceDocumentFileName);
            htmlBaseName = "Temp";
            htmlFileName = "./" + htmlBaseName + ".html";
            imageDirectoryName = htmlBaseName + "_files";
            DirectoryInfo dirInfo = new DirectoryInfo(imageDirectoryName);
            if (dirInfo.Exists)
            {
                foreach (var f in dirInfo.GetFiles())
                    f.Delete();
                dirInfo.Delete();
            }
            int imageCounter = 0;
            byte[] byteArray = File.ReadAllBytes(sourceDocumentFileName);
            using (MemoryStream memoryStream = new MemoryStream())
            {
                memoryStream.Write(byteArray, 0, byteArray.Length);
                using (WordprocessingDocument doc =
                    WordprocessingDocument.Open(memoryStream, true))
                {
                    HtmlConverterSettings settings = new HtmlConverterSettings()
                    {
                        PageTitle = "Test Title",
                        CssClassPrefix = "Mso",
                        Css = css,
                        ConvertFormatting = false,
                    };
                    XElement html = HtmlConverter.ConvertToHtml(doc, settings,
                        imageInfo =>
                        {
                            DirectoryInfo localDirInfo = new DirectoryInfo(imageDirectoryName);
                            if (!localDirInfo.Exists)
                                localDirInfo.Create();
                            ++imageCounter;
                            string extension = imageInfo.ContentType.Split('/')[1].ToLower();
                            ImageFormat imageFormat = null;
                            if (extension == "png")
                            {
                                // Convert png to jpeg.
                                extension = "jpeg";
                                imageFormat = ImageFormat.Jpeg;
                            }
                            else if (extension == "bmp")
                                imageFormat = ImageFormat.Bmp;
                            else if (extension == "jpeg")
                                imageFormat = ImageFormat.Jpeg;
                            else if (extension == "tiff")
                                imageFormat = ImageFormat.Tiff;

                            // If the image format isn't one that we expect, ignore it,
                            // and don't return markup for the link.
                            if (imageFormat == null)
                                return null;

                            string imageFileName = imageDirectoryName + "/image" +
                                imageCounter.ToString() + "." + extension;
                            try
                            {
                                imageInfo.Bitmap.Save(imageFileName, imageFormat);
                            }
                            catch (System.Runtime.InteropServices.ExternalException)
                            {
                                return null;
                            }
                            XElement img = new XElement(Xhtml.img,
                                new XAttribute(NoNamespace.src, imageFileName),
                                imageInfo.ImgStyleAttribute,
                                imageInfo.AltText != null ?
                                    new XAttribute(NoNamespace.alt, imageInfo.AltText) : null);
                            return img;
                        });

                    // Note: the xhtml returned by ConvertToHtmlTransform contains objects of type
                    // XEntity.  PtOpenXmlUtil.cs define the XEntity class.  See
                    // http://blogs.msdn.com/ericwhite/archive/2010/01/21/writing-entity-references-using-linq-to-xml.aspx
                    // for detailed explanation.
                    //
                    // If you further transform the XML tree returned by ConvertToHtmlTransform, you
                    // must do it correctly, or entities will not be serialized properly.

                    File.WriteAllText(htmlFileName, html.ToStringNewLineOnAttributes());
                }
            }
            FileInfo fi = new FileInfo(htmlFileName);
            webBrowser1.Navigate(new Uri(fi.FullName));
            webBrowser1.Refresh();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            DirectoryInfo di = new DirectoryInfo(imageDirectoryName);
            if (di.Exists)
            {
                foreach (var file in di.GetFiles().ToList())
                    file.Delete();
                di.Delete();
            }
            FileInfo fi = new FileInfo(htmlFileName);
            fi.Delete();
            e.Cancel = false;
        }
    }
}
